<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/25/2009 *
 * ===============                              Last change: 10/25/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : stats-functions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Automatical purging of outdated mail links       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auto-Loeschung von veralteten Mail-Links         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Init stats system
function initStatsSystem () {
	// Is stats cache loaded?
	if ((!isset($GLOBALS['stats_loaded'])) && (getConfig('STATS_ENABLED') == 'Y')) {
		// Load stats cache
		$GLOBALS['stats_fqfn'] = sprintf("%sinc/cache/stats.cache", getConfig('PATH'));

		// Is the file readable?
		if (isFileReadable($GLOBALS['stats_fqfn'])) {
			// Yes, so load it and eval
			eval(readFromFile($GLOBALS['stats_fqfn']));
		} else {
			// Generate it only
			touch($GLOBALS['stats_fqfn']);
		}

		// Stats are loaded!
		$GLOBALS['stats_loaded'] = true;
	} // END - if
}

// Checks if we have a statistics entry
function isStatsEntrySet ($entry) {
	// Do we have the entry?
	return (isset($GLOBALS['stats'][$entry]));
}

// Increments a statistics entry
function incrementStatsEntry ($entry, $amount=1) {
	// Is it there?
	if (isStatsEntrySet($entry)) {
		// Then increment it
		$GLOBALS['stats'][$entry] += $amount;
	} else {
		// Write it
		$GLOBALS['stats'][$entry] = $amount;
	}
}

// Getter for stats
function getStatsEntry ($entry) {
	// Default is zero
	$stats = 0;

	// Is it there?
	if (isStatsEntrySet($entry)) {
		// Then use it
		$stats = $GLOBALS['stats'][$entry];
	} // END - if

	// Return the value
	return $stats;
}

// Setter for stats
function setStatsEntry ($entry, $value) {
	$GLOBALS['stats'][$entry] = $value;
}

// Filter for flushing statistics
function FILTER_FLUSH_STATS () {
	// Now do we have stats?
	if ((isset($GLOBALS['stats'])) && (getConfig('STATS_ENABLED') == 'Y')) {
		// Then prepare it for writing
		foreach ($GLOBALS['stats'] as $key=>$value) {
			$stats[] = '$GLOBALS[\'stats\'][\'' . $key . '\'] = ' . $value . ';';
		} // END - foreach

		// Add empty line
		$stats[] = '';

		// And flush all out
		writeToFile($GLOBALS['stats_fqfn'], implode("\n", $stats), true);
	} // END - if
}

// [EOF]
?>
